<div class="row" *ngIf="oModel != null">
    <div class="col-md-12">
        <!--Alert-->
        <div class="row">
            <div class="col-md-12">
                <app-alerts #oAlert></app-alerts>
            </div>
        </div>
        <!--ENd Alert-->
        <!--Page Title-->
        <div class="row">
            <div class="col-md-12">
                <h2>Manage Categories</h2>
            </div>
        </div>

        <div class="row">
            <div class="col-md-12">
                &nbsp;
            </div>
        </div>
        <!--End Page Title-->

        <!--Add New-->
        <div class="row">
            <div class="col-md-12">
                <div class="float-right">
                    <input type="button" value="Add Category" class="btn btn-primary" (click)="vAddCat()">
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-md-12">
                &nbsp;
            </div>
        </div>
        <!--End Add New-->
        <!--Search Box-->
        <div class="row">
            <div class="col-md-12 search-box">
                <form name="CatSearchForm" #CatSearchForm="ngForm" novalidate>
                    <div class="row">
                        <div class="col-md-12">
                            <h3>Search</h3>
                        </div>

                    </div>
                    <div class="row">
                        <div class="col-md-4">
                            <label>Category Name</label>
                            <input type="text" name="tbCatName" [(ngModel)]="oModel.searchCrit.catName"
                                class="form-control" maxlength="30">
                        </div>
                        <div class="col-md-4">
                            <label>Status</label>
                            <select name="drpCatStatus" class="form-control" [(ngModel)]="oModel.searchCrit.status">
                                <option *ngFor="let oStatus of oModel.searchCrit.activeStatuses"
                                    [value]="oStatus.statusID">{{oStatus.statusName}}</option>
                            </select>
                        </div>
                        <div class="col-md-4">
                            <br>
                            <input type="button" class="btn btn-secondary" [value]="btnSearchLabel"
                                (click)="vSearchCats()">
                        </div>
                    </div>
                </form>
            </div>
        </div>
        <div class="row">
            <div class="col-md-12">
                &nbsp;
            </div>
        </div>
        <!--End Of Search Box-->

        <!--Search Results-->
        <div class="row">
            <div class="col-md-12 col-sm-12 col-12 table">
                <!--Table Header-->
                <div class="row header">
                    <div class="col-md-2 col-sm-2 col-2">
                        ID
                    </div>
                    <div class="col-md-4 col-sm-4 col-4">
                        Name
                    </div>
                    <div class="col-md-2 col-sm-2 col-2">
                        Status
                    </div>
                    <div class="col-md-4 col-sm-4 col-4">
                        Action
                    </div>
                </div>
                <!--ENd Of Table Header-->
                <!--Table Records-->
                <div class="row record" *ngFor="let oCat of oModel.searchCrit.searchResults">
                    <div class="col-md-2 col-sm-2 col-2">
                        {{oCat.categoryId}}
                    </div>
                    <div class="col-md-4 col-sm-4 col-4">
                        {{oCat.categoryName}}
                    </div>
                    <div class="col-md-2 col-sm-2 col-2">
                        <input type="checkbox" readonly [(ngModel)]="oCat.categoryIsActive">
                    </div>
                    <div class="col-md-4 col-sm-4 col-4">
                        <div class="dropdown">
                            <button class="btn btn-light dropdown-toggle" type="button" id="dropdownMenuButton"
                                data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                Actions
                            </button>
                            <div class="dropdown-menu" aria-labelledby="dropdownMenuButton">
                                <a class="dropdown-item hand-cursor" (click)="vEdit(oCat)">Edit</a>
                                <a class="dropdown-item hand-cursor" (click)="vDelete(oCat)">Delete</a>
                                <a class="dropdown-item hand-cursor" (click)="vToggleActiveStatus(oCat)">{{oCat.categoryIsActive ? "Deactivate" : "Activate"}}</a>
                            </div>
                        </div>
                    </div>
                </div>

                <!--End Of Table Records-->
            </div>
        </div>
        <div class="row">
            <div class="col-md-12">
                &nbsp;
            </div>
        </div>
        <!--End Of Search Results-->
        <!--Pagination-->
        <div class="row">
            <div class="col-md-12">
                <div class="row">
                    <div class="col-md-3">
                        <select name="drpRecPerPages" class="form-control"
                            [(ngModel)]="oModel.pagerSettings.selectedRecordPerPage">
                            <option *ngFor="let oRecordPerPage of oModel.pagerSettings.recordsPerPage"
                                [(value)]="oRecordPerPage.labelID">{{oRecordPerPage.labelName}}</option>

                        </select>
                    </div>
                    <div class="col-md-6">
                        <div class="row">
                            <div class="col-md-1">
                                &nbsp;
                            </div>
                            <div class="col-md-10">
                                <nav aria-label="...">
                                    <ul class="pagination justify-content-center">
                                        <li class="page-item" *ngIf="oModel.pagerSettings.currentPage > 1">
                                            <a class="page-link" href="#" tabindex="-1">Previous</a>
                                        </li>
                                        <ng-container *ngFor="let oPage of oModel.pagerSettings.pages">
                                            <li
                                                class="page-item {{oPage == oModel.pagerSettings.currentPage ? 'active' : ''}}">
                                                <a class="page-link" href="#">{{oPage}}</a></li>


                                        </ng-container>


                                        <li class="page-item"
                                            *ngIf="oModel.pagerSettings.currentPage < oModel.pagerSettings.pages.length">
                                            <a class="page-link" href="#">Next</a>
                                        </li>
                                    </ul>
                                </nav>
                            </div>
                            <div class="col-md-1">
                                &nbsp;
                            </div>
                        </div>

                    </div>
                    <div class="col-md-3">
                        <div class="row">
                            <div class="col-md-4">
                                <label class="float-right">Go To:</label>
                            </div>
                            <div class="col-md-8">
                                <select name="drpPages" class="form-control"
                                    [(ngModel)]="oModel.pagerSettings.currentPage">
                                    <option *ngFor="let oPage of oModel.pagerSettings.pages" [(value)]="oPage">{{oPage}}
                                    </option>

                                </select>

                            </div>
                        </div>

                    </div>
                </div>
            </div>
        </div>
        <!--End Of Pagination-->

        <!--Add/Edit Modal-->
        <!-- Button trigger modal -->
        <button type="button" class="btn btn-primary hide-me" #btnOpenAddEditModal data-toggle="modal"
            data-target="#AddEditModal">
            Open Add/Edit Modal
        </button>

        <!-- Modal -->
        <div class="modal fade" id="AddEditModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLongTitle"
            aria-hidden="true" data-backdrop="static" data-keyboard="false">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="exampleModalLongTitle">Add / Edit Category</h5>
                        <button type="button" class="close" #btnCloseAddEditModal data-dismiss="modal"
                            aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">

                        <form name="frmAddEditCat" #frmAddEditCat="ngForm" novalidate>


                            <div class="row">
                                <div class="col-md-12">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <label>Name <span class="error"
                                                    *ngIf="tbCategoryName.invalid && (tbCategoryName.dirty || tbCategoryName.touched)">*</span></label>
                                            <input type="text" name="tbCategoryName" #tbCategoryName="ngModel"
                                                [(ngModel)]="oModel.model.categoryName" class="form-control"
                                                maxlength="30" required>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            &nbsp;
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <label>Description</label>
                                            <textarea name="tbCategoryDesc" [(ngModel)]="oModel.model.categoryDesc"
                                                rows="5" cols="60" maxlength="3000">

                                        </textarea>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            &nbsp;
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <input type="checkbox" name="chkIsActive"
                                                [(ngModel)]="oModel.model.categoryIsActive">&nbsp;Is Active
                                        </div>
                                    </div>
                                </div>
                            </div>

                        </form>

                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-primary"
                            (click)="vSave(frmAddEditCat.valid)">{{btnSave}}</button>
                        <button type="button" class="btn btn-primary" data-dismiss="modal">Cancel</button>

                    </div>
                </div>
            </div>
        </div>
        <!--End Add/Edit Modal-->




    </div>
</div>
<div class="row" *ngIf="oModel == null">
    <h1>Loading...</h1>
</div>